package multithreading;

import model.Direction;

public class ThreadedGameBoard extends GameBoardThreading {
    private final int refreshRate;
    private final Display display;

    public ThreadedGameBoard(int refreshRate, Display d) {
        super("PacMan");
        this.display = d;
        this.refreshRate = refreshRate;
    }
    
    public synchronized void changePlayerDirection(int player, Direction d) {
        super.changePlayerDirection(player, d);
    }
    
    @Override
    protected void logic() {
        System.out.println("PacMan thread: started");
        while (!Thread.interrupted()){
            
            synchronized(this) {
                movePlayers();
            }
            
            display.refresh();
            
            try {
                Thread.sleep(refreshRate);
            } catch (InterruptedException ex) {
                System.out.println("PacMan: interrupted");
                break;
            }
        }
    }
}
